
from basics import *
import numpy
from numpy.core.numerictypes import *
from VTKHelperFunctions import *
from scipy.interpolate import splrep,splev

def easydir(x):
  if not os.path.exists(x):
    try:
      os.makedirs(x)
      print "Making",x
    except:
      print "Already there!",x

def MakeThumbnail(f,mag=4,pct=40,z1=0,z2=0,s1=-20,s2=20,inv=1,q=85,j=""):
   if type(f) == numpy.ndarray:
      D = f
   else:
      F = FITS(f)
      D = F.data()
      F.close()
      j = f.replace(".fits.gz",".jpg").replace(".fits","mag%02d.jpg" % (int(mag)))
   if mag != 1: D = VTKShrinkN(D,mag,numret=1,usemean=1)
   if not z1 and not z2:
      Du = compress(D.ravel(),D.ravel())
      m = getpct(Du,pct)
      s = 1.49*median(abs(Du-m))
      z1 = m + s1*s
      z2 = m + s2*s
#      print "M,S,Z1,Z2 = (%.3f,%.3f,%.3f,%.3f)" % (m,s,z1,z2)
   I = NumToVTKImage(D)
   M = vtkImageMapToWindowLevelColors()
   M.SetWindow((z2-z1)*pow(-1,inv))
   M.SetLevel(0.5*(z2+z1))
   M.SetOutputFormatToRGB()
   M.SetInput(I)
   J = vtkJPEGWriter()
   J.ProgressiveOff()
   J.SetQuality(q)
   J.SetInput(M.GetOutput())
   J.SetFileName(j)
   print "Writing %s." % (j)
   J.Write()

def EasyStat(x,m,c=3,pct=25):
    x = compress(m*x,x)
    v = 0.0
    if len(x):
#       s = sort(x)
#       a = getpct(s,30)
#       sa = (s-a)
#       b = 1.49*median(abs(sa))
#       s = compress(between(sa,-c*b,c*b),s)
#       v = median(s)
       s = sort(x)
       e = diff(s)
       p = s[:-1]+e/2.
       u = int(pct*len(e))+1
       e,p = take([e,p],argsort(e)[:u],1)
       v = median(p)
    return v

def EasyPatch(f):
    x = arange(f.shape[0])
    xu,fu = compress(f,[x,f],1)
    if len(xu) > 3:
       tck = splrep(xu,fu,s=0,k=1)
       fx = splev(x,tck)
    else:
       fx = mean(fu)*ones(x.shape,x.dtype)
    return fx


